<?php
 define('DATAPATH','./data'); //     *.dat  *.txt,    
 define('DEFAULTPHRASES','100'); //     ( n)

 // 

 function fatal_error ($n, $str) {
  print "<p><b>!</b><br>";
  $msg="";
  switch ($n) {
   case 1: $msg=" '$str'    "; break;
   case 2: $msg="  '$str'  "; break;
   case 3: $msg="  '$str'  "; break;
   case 4: $msg="  '$str'  "; break;
   case 5: $msg="  ($str)"; break;
   case 6: $msg="  '$str'  "; break;
   case 7: $msg="   '$str'"; break;
   case 8: $msg="   '$str'"; break;
   case 9: $msg="  '$str'"; break;
   case 10: $msg="      ($str)"; break;
   case 11: $msg="        ($str)!"; break;
   case 12: $msg="  ($str)"; break;
   case 13: $msg="   -     ($str)!"; break;
   case 14: $msg="       ($str)!"; break;
   case 15: $msg="  ($str)"; break;
   case 16: $msg="       ($str)"; break;
   case 17: $msg="     ($str)"; break;
   default: $msg=" !   ";
  }
  print "$msg</p>";
  exit($n);
 }

 function readData ($name) {
  $name=DATAPATH.'/'.$name;
  if ((!file_exists($name)) or (filesize($name)==0)) {
   fatal_error (1,$name);
  }
  $fp = fopen($name, "r");
  $text = fread($fp, filesize($name));
  fclose($fp);
  return $text;
 }

 function parseStrings ($text) {
  $arr = explode ("\n",$text);
  $data = array ();
  foreach ($arr as $val) {
   while (true) {
    $val=str_replace ("  "," ",trim($val));
    if (!is_integer(strpos($val,"  "))) break;
   }
   $pos=strpos($val,"#");
   if (is_integer($pos)) $val = substr ($val,0,$pos);
   if (strlen($val)>0) array_push ($data,$val);
  }
  return $data;
 }

 function readSuch () {
  $temp = parseStrings(readData ('such.txt'));
  $such = array (
   "such_word" => array (),
   "such_r" => array (),
   "such_o" => array (),
   "such_num" => array ()
  );
  foreach ($temp as $val) {
   $words  = explode (" ",$val);
   array_push($such['such_word'],$words[0]);
   array_push($such['such_r'],$words[1]);
   array_push($such['such_o'],$words[2]);
   array_push($such['such_num'],$words[3]);
  }
  return $such;
 }

 function readSuchDat () {
  $temp = parseStrings(readData ('such.dat'));
  $sp = array (
   "sp_IP1" => array (), "sp_RP1" => array (), "sp_DP1" => array (),
   "sp_VP1" => array (), "sp_TP1" => array (), "sp_PP1" => array (),
   "sp_IP2" => array (), "sp_RP2" => array (), "sp_DP2" => array (),
   "sp_VP2" => array (), "sp_TP2" => array (), "sp_PP2" => array ()
  );
  foreach ($temp as $val) {
   $words  = explode (" ",$val);
   array_push($sp['sp_IP1'],$words[0]);   array_push($sp['sp_RP1'],$words[1]);   array_push($sp['sp_DP1'],$words[2]);
   array_push($sp['sp_VP1'],$words[3]);   array_push($sp['sp_TP1'],$words[4]);   array_push($sp['sp_PP1'],$words[5]);
   array_push($sp['sp_IP2'],$words[6]);   array_push($sp['sp_RP2'],$words[7]);   array_push($sp['sp_DP2'],$words[8]);
   array_push($sp['sp_VP2'],$words[9]);   array_push($sp['sp_TP2'],$words[10]);  array_push($sp['sp_PP2'],$words[11]);
  }
  return $sp;
 }

 function readPril () {
  $temp = parseStrings(readData ('pril.txt'));
  $pril = array (
   "pril_word" => array (),
   "pril_num" => array ()
  );
  foreach ($temp as $val) {
   $words  = explode (" ",$val);
   array_push($pril['pril_word'],$words[0]);
   array_push($pril['pril_num'],$words[1]);
  }
  return $pril;
 }

 function readPrilDat () {
  $temp = parseStrings(readData ('pril.dat'));
  $pp = array (
   "pp_IPM1" => array (), "pp_RPM1" => array (), "pp_DPM1" => array (),  "pp_VPM1" => array (), "pp_TPM1" => array (), "pp_PPM1" => array (),
   "pp_IPZ1" => array (), "pp_RPZ1" => array (), "pp_DPZ1" => array (),  "pp_VPZ1" => array (), "pp_TPZ1" => array (), "pp_PPZ1" => array (),
   "pp_IPS1" => array (), "pp_RPS1" => array (), "pp_DPS1" => array (),  "pp_VPS1" => array (), "pp_TPS1" => array (), "pp_PPS1" => array (),
   "pp_IP2" => array (), "pp_RP2" => array (), "pp_DP2" => array (), "pp_VP2" => array (), "pp_TP2" => array (), "pp_PP2" => array ()
  );
  foreach ($temp as $val) {
   $words  = explode (" ",$val);
   array_push($pp['pp_IPM1'],$words[0]); array_push($pp['pp_RPM1'],$words[1]); array_push($pp['pp_DPM1'],$words[2]); array_push($pp['pp_TPM1'],$words[3]); array_push($pp['pp_PPM1'],$words[4]);
   array_push($pp['pp_VPM1'],$words[0]); //!!!  M(.)
   array_push($pp['pp_IPZ1'],$words[5]); array_push($pp['pp_RPZ1'],$words[6]); array_push($pp['pp_DPZ1'],$words[7]); array_push($pp['pp_VPZ1'],$words[8]); array_push($pp['pp_TPZ1'],$words[9]);array_push($pp['pp_PPZ1'],$words[10]);
   array_push($pp['pp_IPS1'],$words[11]);array_push($pp['pp_RPS1'],$words[12]);array_push($pp['pp_DPS1'],$words[13]);array_push($pp['pp_TPS1'],$words[14]);array_push($pp['pp_PPS1'],$words[15]);
   array_push($pp['pp_VPS1'],$words[11]);//!!!  S(.)
   array_push($pp['pp_IP2'],$words[16]); array_push($pp['pp_RP2'],$words[17]); array_push($pp['pp_DP2'],$words[18]); array_push($pp['pp_TP2'],$words[19]); array_push($pp['pp_PP2'],$words[20]);
   array_push($pp['pp_VP2'],$words[16]);//!!!  .
  }
  return $pp;
 }

 function readGlag () {
  $temp = parseStrings(readData ('glag.txt'));
  $glag = array (
   "glag_word" => array (),
   "glag_num" => array (),
   "glag_prich" => array (),
   "glag_v" => array (),
   "glag_p" => array (),
   "glag_ob" => array ()
  );
  foreach ($temp as $val) {
   $words  = explode (" ",$val);
   array_push($glag['glag_word'],$words[0]);
   array_push($glag['glag_num'],$words[1]);
   array_push($glag['glag_prich'],$words[2]);
   array_push($glag['glag_v'],$words[3]);
   array_push($glag['glag_p'],$words[4]);
   array_push($glag['glag_ob'],$words[5]);
  }
  return $glag;
 }

 function readGlagDat () {
  $temp = parseStrings(readData ('glag.dat'));
  $gp = array (
   "gp_NF" => array (), 
   "gp_PNVED1" => array (), "gp_PNVED2" => array (), "gp_PNVED3" => array (), "gp_PNVMN1" => array (), "gp_PNVMN2" => array (), "gp_PNVMN3" => array (),
   "gp_PPVED3M" => array (), "gp_PPVED3Z" => array (), "gp_PPVED3S" => array (), "gp_PPVMN3" => array (), 
   "gp_PNED" => array (), "gp_PNMN" => array (), 
   "gp_PDZNV" => array (), "gp_PDZPV" => array (), 
   "gp_PSZNV" => array (), "gp_PSZPV" => array (), 
   "gp_DNV" => array (), "gp_DPV" => array ()
  );
  foreach ($temp as $val) {
   $words  = explode (" ",$val);
   array_push($gp['gp_NF'],$words[0]);
   array_push($gp['gp_PNVED1'],$words[1]); array_push($gp['gp_PNVED2'],$words[2]); array_push($gp['gp_PNVED3'],$words[3]); array_push($gp['gp_PNVMN1'],$words[4]); array_push($gp['gp_PNVMN2'],$words[5]); array_push($gp['gp_PNVMN3'],$words[6]);
   array_push($gp['gp_PPVED3M'],$words[7]); array_push($gp['gp_PPVED3Z'],$words[8]); array_push($gp['gp_PPVED3S'],$words[9]); array_push($gp['gp_PPVMN3'],$words[10]);
   array_push($gp['gp_PNED'],$words[11]); array_push($gp['gp_PNMN'],$words[12]);
   array_push($gp['gp_PDZNV'],$words[13]); array_push($gp['gp_PDZPV'],$words[14]);
   array_push($gp['gp_PSZNV'],$words[15]); array_push($gp['gp_PSZPV'],$words[16]);
   array_push($gp['gp_DNV'],$words[17]); array_push($gp['gp_DPV'],$words[18]);
  }
  return $gp;
 }

 function readNar () {
  $temp = parseStrings(readData ('nar.txt'));
  $nar = array (
   "nar_word" => array (),
   "nar_cat" => array ()
  );
  foreach ($temp as $val) {
   $cat  = strrchr ($val," ");
   $word = substr ($val,0,-1*strlen($cat));
   array_push($nar['nar_word'],trim($word));
   array_push($nar['nar_cat'],trim($cat));
   //$words  = explode (" ",$val);
   //array_push($nar['nar_word'],$words[0]);
   //array_push($nar['nar_cat'],$words[1]);
  }
  return $nar;
 }
?>